#include <iostream>
#include <vector>
using namespace std;
 
//Line A

#include "TTree.h"
#include "TFile.h"
#include "TLorentzVector.h"
#include "TVector3.h"
#include "TH1.h"
#include "TH2.h"
#include "TF1.h"

//Line B
//My include file                                                                                                                                                                 
#include "myTree.h"
//Line C

//Line D

int main(int argc, char **argv) {
  cout<<"Hello World"<<endl;
  //Line M1
  //Define integer nToRun;                                                                                                                                                        
  int nToRun = 1;
  //Line M2
  //Define the histograms                                                                                                                                                         
  TH2D *hBetaVsP     = new TH2D("hBetaVsP","myTitle",60,0.0,6.0,110,0.0,1.1);
  TH2D *hBetaVsPPro  = new TH2D("hBetaVsPPro","myTitle",60,0.0,6.0,110,0.0,1.1);
  //Line M3
  //Setup the output file                                                                                                                                                         
  TFile *outFile = new TFile("myOutFile.root","RECREATE");
  //Line M4

  //Setup the input file and tree                                                                                                                             
  TFile* inFile=new TFile("./skim11_005367.hipo.root");
  //Get tree out of the file
  TTree *inTree = (TTree*)inFile->Get("clas12");
  //Define the tree structure
  myTree_t myTree;
  //Get the tree branches into myTree structure
  getBranchesStage1(inTree,&myTree);
  //Find out how many events are in the tree and set to nToRun
  nToRun = inTree->GetEntries();
  //Print the number of events to process in the terminal
  cout<<"Number of events to process = "<<nToRun<<endl;

  //Line M5
  for(Int_t i=0;i<nToRun;i++){
    inTree->GetEntry(i);
    //Print every 50000 events                                                                                                                                                    
    if (i%50000 == 0) cout<<"Events processed = "<<i<<endl;
    //Find out how many particles are in the event                                                                                                                                
    int nREC_Particle = myTree.REC_Particle_pid->size();
    //Line L1
    //Loop over each particle in the event                                                                                                                                        
    for(int index = 0; index<nREC_Particle; index++){
      int pid   = myTree.REC_Particle_pid->at(index);
      Float_t px = myTree.REC_Particle_px->at(index);
      double py = myTree.REC_Particle_py->at(index);
      double pz = myTree.REC_Particle_pz->at(index);
      double p  = sqrt(pow(px,2)+pow(py,2)+pow(pz,2));
      double beta   = myTree.REC_Particle_beta->at(index);
      //Line P1                                                                                                                                                                   
      hBetaVsP->Fill(p,beta);
      if (pid == 2212) hBetaVsPPro->Fill(p,beta);
      //Line P2                                                                                                                                                                   
    }
    //Line L2
  }

  //Line M6
  outFile->cd();

  hBetaVsP->Write();
  hBetaVsPPro->Write();

  outFile->Write();
  //Line M7
  return 0;
}




